*  Program...........: CORE.PRG
*  Author............: Valdis Matison
*} Project...........: 
*  Created...........: 03/31/1994
*  Copyright.........: (c) Matison Consulting Group Inc., 1994
*) Description.......: Main program for Bug Report
*] Dependencies......: 
*  Calling Samples...: 
*  Parameter List....: 
*  Returns...........: 
*  Major change list.: 

*--
*-- This one variable will set the characteristics to development or 
*-- production. True means development so don't exit to DOS when quitting
*--

public gl_isdevel
gl_isdevel = .t.

do setenv					&& Setup environment
do globalvar				&& Create global variables
*do errorset				&& Set up error handler
do syssetup					&& Help path, resource, color sets

set procedure to library	&& Set up path and environment information
set library to "foxtools.fll" additive
set library to "jkey.fll" additive

modify window screen ;
       zoom title "Bugs R Us" ;
       FONT "MS Sans Serif", 8 ;
       ICON FILE LOCFILE("ICON\MAT.ICO","ICO", ;
		                 "Where is Matlogo?") ;
       COLOR RGB(,,,0,128,64) ;
	   minimize

modify window screen nozoom
set sysmenu to
clear

do title.spr
do li_opendbf				&& Open application files
=inkey(2,"HM")
clear

do mainmenu.mpr
read valid mainhand()

set sysmenu to default
close databases
cancel
quit

*-- eop CORE.PRG



procedure mainhand
private m.temp
*-- Global variable that tells me to quit
if gl_quiting
 return .t.
endif

if gl_error			&& Has an error occurred?

 activate screen 
 clear
 do setenv					&& Setup environment
 do globalvar				&& Create global variables
 set procedure to library	&& Set up path and environment information
 do syssetup				&& Help path, resource, color sets
 set sysmenu to 
 do mainmenu.mpr
 set sysmenu automatic
 do li_opendbf				&& Open application files
 gl_error = .f.

 return .f.			&& The error handling mechanism will return me to the validation
endif

* now see what application the user wants to start

IF LEN(gc_nxtproc) > 0		  && Launches an SPR which was
   m.temp = gc_nxtproc		  && specified from the menu
   gc_nxtproc = ""
   DO (m.temp)
   RETURN .F.
ENDIF

* the following is required when clicking on other windows

lc_ontop = wontop()
m.temp   = ""

DO CASE						  		&& Handles all other cases
 case gc_active = "ACTICODE"
  m.temp = "ACTICODE.SPR"    
ENDCASE

return .f.
*--
*-- eop mainhand



procedure setenv
*-- Creates global environment settings 

public gc_bell, gc_century, gc_clock, gc_debug, gc_deleted

gc_bell    = set("BELL")
gc_century = set("CENTURY")
gc_clock   = set("CLOCK")

set bell off 
set century on
SET COMPATIBLE off
set clock off
SET DEBUG ON
set deleted on
set echo off
set escape off
set exclusive on
set near on
set refresh to 0,300
set resource off
set safety off
set scoreboard off 
set status off  
set sticky on
set talk off

set function "F2" to ""
set function "F3" to ""
set function "F4" to ""
set function "F5" to ""
set function "F6" to ""
set function "F7" to ""
set function "F8" to ""
set function "F9" to ""
set function "F10" to ""
*--
*-- eop setenv


procedure globalvar
*-- Define all global variables here
*--

public gl_adding, gl_allocat, gl_beep, gl_browsin, gl_edit, gl_editing, ;
       gl_error, gl_false, gl_file, gl_found, gl_filtnon, gl_filtsim, ;
       gl_filtadv, gl_hdline, gl_linebro, gl_off, gl_oktopri, gl_oktoadd

public gl_oktorea, gl_online, gl_query, gl_quiting, gl_record, gl_release, ;
       gl_reports, gl_screen, gl_switch, gl_true, gl_window
       
public gc_active, gc_agree, gc_backcol, gc_bralias, gc_brotitl, gc_brownam, gc_char, gc_fldname, ;
       gc_default, gc_dest, gc_firstob, gc_filtexp, gc_getcolr, gc_getstat, ;
       gc_getacti, gc_key, gc_nocolor, gc_message, gc_nxtproc

public gc_resourc, gc_path, gc_proc, gc_report, gc_saycolr, gc_seekmsg, ;
       gc_tempf01, gc_tmppath

public gn_close, gn_false, gn_faxok, gn_gstrate, gn_number, gn_pstrate, ;
       gn_recno, gn_true, gk_down, gk_delete, gk_esckey, gk_enter, gk_endkey, ;
       gk_f2, gk_f3, gk_f4, gk_f5, gk_f6, gk_f7, gk_f8, gk_f9, gk_homekey

public gk_insert, gk_left, gk_mouse, gk_pgdn, gk_pgup, gk_readky, gk_right, ;
       gk_space, gk_up, ga_tagname, gd_blank

*-- Global logical variables
*--

gl_adding  = .f.	&& used for variables that can only be manipulated only once such as ID's.
gl_allocat = .f.    && True means this brows item can be broken down into a deeper list
gl_beep    = .t.	&& beep is on in warnings
gl_browsin = .f.	&& lets me know if a browse is active
gl_edit    = .f.	&& Menu flag
gl_editing = .f.	&& if .t. then a file is open for editing, viewing, or adding
gl_error   = .f.    && Has an error occurred?
gl_false   = .f.	&& False
gl_file    = .f.	&& Menu flag
gl_found   = .f.	&& holds results of seeks or locates
gl_filtnon = .f.	&& When .t. states which fiter is active
gl_filtsim = .f.	&& Simple filter expression
gl_filtadv = .f.	&& Advanced filter expression
gl_hdline  = .f.	&& If true don't allow Table view option used for header/line item tables
gl_linebro = .f.	&& Blanks out "Order", "SEEK" when browsing in detail of header/detail screens
gl_off     = .t.	&& Some menu options will not be accessible right away
gl_oktopri = .f.	&& Tells me if its ok to print a report
gl_oktoadd = .t.    && Says if records can be added
gl_oktorea = .f.
gl_online  = .f.	&& Required for modem menu
gl_query   = .f.	&& Menu flag
gl_quiting = .f.	&& close all files and return to dos
gl_record  = .t.	&& Menu flag
gl_release = .t.	&& If a dialog box gets popped up it shouldn';t deactivate menu options etc. in the li_reclose module
gl_reports = .f.	&& Menu flag
gl_screen  = .f.	&& Menu flag
gl_switch  = .t.    && Global toggle switch, change from false to true and back
gl_true    = .t.	&& True
gl_window  = .f.	&& Menu flag

*-- Global Character variables
*--
gc_active  = " "			&& This is the global active window
gc_agree   = "AGREEONE"		&& Application: Used for foundation read of multiple windows query
gc_backcol = "N/BU"			&& Define system colors and border strings
gc_bralias = ""				&& Alias name of file for browse window
gc_brotitl = ""				&& Title of browse window
gc_brownam = "BROWWIND"		&& Name of an inactive browse window - 
                            && used in li_bromake and li_broshow
gc_char    = ""				&& general purpose variable
gc_fldname = ""				&& Used in Seek as a field name that describes the key
gc_dbftag  = ""				&& Used for seekdata.prg
gc_default = ""
gc_dest    = "Printer"		&& States where reports are generated
gc_firstob = ""				&& States which object is first in read for show gets
gc_filtexp = ""				&& This is the filter exprssion
gc_getcolr = ",GR+/N"		&& Color of active gets variables
gc_getstat = ""				&& Color when get active but not selected
gc_getacti = ""				&& Color when get acitve and selected
gc_key	   = ""				&& Used in Seek as the key field to seek on
gc_nocolor = ""				&& Say color that displays blank on screen
gc_message = ""				&& message to be displayed when needed.
gc_nxtproc = ""     			&& next procedure
gc_resourc = "LI_usr25.DBF"		&& system resource file
gc_path    = ""
gc_proc    = ""				&& name of currently executing procedure
gc_report  = ""				&& Global report name
gc_saycolr = ",W+/N"		&& Say color of gets when not editing
gc_seekmsg = ""				&& Used in Seek as the field to lookup in the message list
gc_tempf01 = "00000001.DBF"	&& Temporary file name
gc_tmppath = "C:\"

*-- Global numeric variables
*--
gn_close   = 0	
gn_false   = 0		&& Numeric false
gn_faxok   = 1		&& Global flag - True if fax manager is installed
gn_gstrate = 0.07
gn_number  = 0.0	&& general purpose number
gn_pstrate = 0.08
gn_recno   = 1		&& record number set to top of file
gn_true    = 1		&& Numeric true

*--	Keyboard input
gk_down    = 24
gk_delete  = 7
gk_esckey  = 27      
gk_enter   = 13
gk_endkey  = 6      
gk_f2      = -1 
gk_f3      = -2 
gk_f4      = -3 
gk_f5      = -4 
gk_f6      = -5 
gk_f7      = -6
gk_f8      = -7
gk_f9      = -8
gk_homekey = 1      
gk_insert  = 22
gk_left    = 19 
gk_mouse   = 115
gk_pgdn    = 3      
gk_pgup    = 18      
gk_readky  = 1
gk_right   = 4 
gk_space   = 32
gk_up      = 5

*-- Global arrays
*--
dime ga_tagname[ 3 ]		&& Used to hold the tag names for each table
store "" to ga_tagname

*-- Global date variables
*-- 
gd_blank   = {  /  /  }		&& overall blank date

*-- System variables
*--
_genpd = "LI_PRNDR.APP"

*--
*-- eop globalvar


procedure syssetup
*-- Help, path, resource, color sets
*--
private lc_scheme1, ;
        lc_say, ;
        lc_back

on key label F1 HELP
gc_path = sys(5) + sys(2003)

set default to ( gc_path )

gc_path = gc_path + ";" ;
        + gc_path + "\DATA;" ;
        + gc_path + "\SCREEN;" ;
        + gc_path + "\MENU;" ;
        + gc_path + "\ICON;" ;
        + gc_path + "\REPORT"

set path to ( gc_path )

*-- Determine the attributes of the blank out color set for read show
*-- routines for say fields
*--

lc_scheme1 = scheme(1)
lc_say     = scheme( 1,1 )
lc_back    = substr( lc_say, at( "/", lc_say) + 1 )

gc_nocolor = lc_back + "/" + lc_back + ;
              substr( lc_scheme1, at( ",", lc_scheme1 ) )
gc_getstat =  scheme(1,2) + "," + scheme(1,2)	&& Color when get acitve but not selected
gc_getacti =  scheme(1,2) + "," + scheme(1,6)	&& Color when get acitve and selected

*--
*-- eop syssetup


procedure errorset
*-- Creates error system

*ON ERROR DO FPWERROR WITH ERROR(), MESSAGE(), MESSAGE(1), ;
*    SYS(16), LINENO(), SYS(102), SYS(100), SYS(101), LASTKEY(), ;
*    ALIAS(), SYS(18), SYS(5), SYS(12), SYS(6), SYS(2003), WONTOP(), ;
*    SYS(2011), SYS(2018), SET("CURSOR")

*-- 
*-- eop errorset